<?php
class ControllerSaleDesignDist extends Controller {
	private $error = array();
 
	public function index() {
		$this->load->language('sale/design_dist');
  
		$this->document->setTitle($this->language->get('heading_title'));
 		
		$this->load->model('sale/design_dist');
		
		$this->getList();
	}

	public function insert() {
		$this->load->language('sale/design_dist');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('sale/design_dist');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_sale_design_dist->addSize($this->request->post);
			
			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}
			
			$this->redirect($this->url->link('sale/design_dist', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getForm();
	}

	public function update() {
		$this->load->language('sale/design_dist');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('sale/design_dist');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_sale_design_dist->editSize($this->request->get['designer_reward_distribution_id'], $this->request->post);
			
			$this->session->data['success'] = $this->language->get('text_success');
			
			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}
			
			$this->redirect($this->url->link('sale/design_dist', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getForm();
	}

	public function delete() { 
		$this->load->language('sale/design_dist');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('sale/design_dist');
		
		if (isset($this->request->post['selected']) && $this->validateDelete()) {
      		foreach ($this->request->post['selected'] as $designer_reward_distribution_id) {
				$this->model_sale_design_dist->deleteSize($designer_reward_distribution_id);	
			}
						
			$this->session->data['success'] = $this->language->get('text_success');
			
			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}
			
			$this->redirect($this->url->link('sale/design_dist', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getList();
	}

	private function getList() {
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'designer_customer';
		}
		 
		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}
		
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}
		
		$url = '';
		
		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}	
		
		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
			
  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('sale/design_dist', 'token=' . $this->session->data['token'] . $url, 'SSL'),
      		'separator' => ' :: '
   		);
							
		$this->data['insert'] = $this->url->link('sale/design_dist/insert', 'token=' . $this->session->data['token'] . $url, 'SSL');
		$this->data['delete'] = $this->url->link('sale/design_dist/delete', 'token=' . $this->session->data['token'] . $url, 'SSL');	
	
		$this->data['customer_groups'] = array();

		$data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_admin_limit'),
			'limit' => $this->config->get('config_admin_limit')
		);
		
		$customer_group_total = $this->model_sale_design_dist->getTotalSizes();
		
		$results = $this->model_sale_design_dist->getSizes($data);

		foreach ($results as $result) {
			$action = array();
			
			$action[] = array(
				'text' => $this->language->get('text_edit'),
				'href' => $this->url->link('sale/design_dist/update', 'token=' . $this->session->data['token'] . '&designer_reward_distribution_id=' . $result['designer_reward_distribution_id'] . $url, 'SSL')
			);		
		
			$this->data['customer_groups'][] = array(
				'designer_reward_distribution_id' => $result['designer_reward_distribution_id'],
				'reward_amount' => $result['reward_amount'],
				'payment_date' => $result['payment_date'],
				'currency' => $result['currency'],
				'payment_details' => $result['payment_details'],
				'designer_customer'              => $result['designer_customer'] . (($result['designer_reward_distribution_id'] == $this->config->get('config_designer_reward_distribution_id')) ? $this->language->get('text_default') : null),
				'selected'          => isset($this->request->post['selected']) && in_array($result['designer_reward_distribution_id'], $this->request->post['selected']),
				'action'            => $action
			);
		}	
	
		$this->data['heading_title'] = $this->language->get('heading_title');
		
		$this->data['text_no_results'] = $this->language->get('text_no_results');

		$this->data['column_name'] = $this->language->get('column_name');
		$this->data['column_reward_amount'] = $this->language->get('column_reward_amount');
		$this->data['column_payment_date'] = $this->language->get('column_payment_date');
		$this->data['column_action'] = $this->language->get('column_action');

		$this->data['button_insert'] = $this->language->get('button_insert');
		$this->data['button_delete'] = $this->language->get('button_delete');
 
 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
		
		if (isset($this->session->data['success'])) {
			$this->data['success'] = $this->session->data['success'];
		
			unset($this->session->data['success']);
		} else {
			$this->data['success'] = '';
		}
		
		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$this->data['sort_name'] = $this->url->link('sale/design_dist', 'token=' . $this->session->data['token'] . '&sort=designer_customer' . $url, 'SSL');
		
		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}
												
		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
				
		$pagination = new Pagination();
		$pagination->total = $customer_group_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_admin_limit');
		$pagination->text = $this->language->get('text_pagination');
		$pagination->url = $this->url->link('sale/design_dist', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');
		
		$this->data['pagination'] = $pagination->render();				

		$this->data['sort'] = $sort; 
		$this->data['order'] = $order;

		$this->template = 'sale/designer_dist_list.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
				
		$this->response->setOutput($this->render());
 	}

	private function getForm() {
		$this->data['heading_title'] = $this->language->get('heading_title');
		
		$this->data['entry_name'] = $this->language->get('entry_name');
		$this->data['entry_reward_amount'] = $this->language->get('entry_reward_amount');
		$this->data['entry_payment_date'] = $this->language->get('entry_payment_date');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

 		if (isset($this->error['designer_customer'])) {
			$this->data['error_name'] = $this->error['designer_customer'];
		} else {
			$this->data['error_name'] = '';
		}

		$url = '';
			
		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
		
		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('sale/design_dist', 'token=' . $this->session->data['token'] . $url, 'SSL'),
      		'separator' => ' :: '
   		);
			
		if (!isset($this->request->get['designer_reward_distribution_id'])) {
			$this->data['action'] = $this->url->link('sale/design_dist/insert', 'token=' . $this->session->data['token'] . $url, 'SSL');
		} else {
			$this->data['action'] = $this->url->link('sale/design_dist/update', 'token=' . $this->session->data['token'] . '&designer_reward_distribution_id=' . $this->request->get['designer_reward_distribution_id'] . $url, 'SSL');
		}
		  
    	$this->data['cancel'] = $this->url->link('sale/design_dist', 'token=' . $this->session->data['token'] . $url, 'SSL');

		if (isset($this->request->get['designer_reward_distribution_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$customer_group_info = $this->model_sale_design_dist->getSize($this->request->get['designer_reward_distribution_id']);
		}

		if (isset($this->request->post['designer_customer'])) {
			$this->data['designer_customer'] = $this->request->post['designer_customer'];
		} elseif (isset($customer_group_info)) {
			$this->data['designer_customer'] = $customer_group_info['designer_customer'];
		} else {
			$this->data['designer_customer'] = '';
		}

		if (isset($this->request->post['reward_amount'])) {
			$this->data['reward_amount'] = $this->request->post['reward_amount'];
		} elseif (isset($customer_group_info)) {
			$this->data['reward_amount'] = $customer_group_info['reward_amount'];
		} else {
			$this->data['reward_amount'] = '';
		}
		if (isset($this->request->post['currency'])) {
			$this->data['currency'] = $this->request->post['currency'];
		} elseif (isset($customer_group_info)) {
			$this->data['currency'] = $customer_group_info['currency'];
		} else {
			$this->data['currency'] = '';
		}
		if (isset($this->request->post['payment_details'])) {
			$this->data['payment_details'] = $this->request->post['payment_details'];
		} elseif (isset($customer_group_info)) {
			$this->data['payment_details'] = $customer_group_info['payment_details'];
		} else {
			$this->data['payment_details'] = '';
		}

		if (isset($this->request->post['payment_date'])) {
			$this->data['payment_date'] = $this->request->post['payment_date'];
		} elseif (isset($customer_group_info)) {
			$this->data['payment_date'] = $customer_group_info['payment_date'];
		} else {
			$this->data['payment_date'] = '';
		}
		
	
		$this->template = 'sale/designer_dist_form.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
				
		$this->response->setOutput($this->render()); 
	}

	private function validateForm() {
		if (!$this->user->hasPermission('modify', 'sale/design_dist')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
 
		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}

	private function validateDelete() {
		if (!$this->user->hasPermission('modify', 'sale/design_dist')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		$this->load->model('setting/store');
		$this->load->model('sale/customer');
      	
		foreach ($this->request->post['selected'] as $designer_reward_distribution_id) {
    		if ($this->config->get('config_designer_reward_distribution_id') == $designer_reward_distribution_id) {
	  			$this->error['warning'] = $this->language->get('error_default');	
			}  
			
			$store_total = $this->model_setting_store->getTotalStoresBySizeId($designer_reward_distribution_id);

			if ($store_total) {
				$this->error['warning'] = sprintf($this->language->get('error_store'), $store_total);
			}
			
			$customer_total = $this->model_sale_customer->getTotalCustomersBySizeId($designer_reward_distribution_id);

			if ($customer_total) {
				$this->error['warning'] = sprintf($this->language->get('error_customer'), $customer_total);
			}
		}
		
		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
?>